/* last test 9 janv 2014 under  Win XP OK */
/* compiled with Turbo C 2.00 */
#include <Dos.h>
#include <time.h>
#include <stdio.h>

#define DSTSTART	(24 * 118 + 2)
#define DSTEND		(24 * 296 + 2)

long   Lt,Ls;
char *bb;
long	timezone = 5L * 60L * 60L;		/* Set for EST soit 1H*/
int	daylight = 1;				/* Apply daylight savings */
int i,j,k,l;

static	char	Days[12] = {
	31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
static	char	*Weekday[7] = {
	"Dim", "Lun", "Mar", "Mer", "Jeu", "Ven", "Sam"};
static	char	*Months[13] = {"...",
	"Jan", "Fev", "Mar", "Avr", "Mai", "Jun",
	"Jul", "Aou", "Sep", "Oct", "Nov", "Dec"};

struct temps {
	unsigned char t_hour;	/* Hours */
	unsigned char t_min;	/* Minutes */
	unsigned char t_sec;	/* Seconds */
	unsigned char t_hund;	/* Hundredths of seconds */
		};
struct Datum {
 char day;	/* Day of the month */
 char mon;	/* Month (1 = Jan) */
 int  year;	/* Current year */
 char Js ;    /* jour de la semaine */
    };

static struct Datum Dt;
static struct temps ti;
static struct tm T;
static struct time Wt;
static struct date dt;


char	*ctime(const long *clock)
{       return(asctime(localtime(clock)));}


static	struct	tm	*comtime(long time, int dst)
{	int	hpery;
	int	i;
	int	cumdays;
        T.tm_sec = time % 60;
	time /= 60;
	T.tm_min = time % 60;
	time /= 60;
	i = time / (1461L * 24L);
	T.tm_year = 70 + (i << 2);
	cumdays = 1461 * i;
	time %= 1461L * 24L;
	for	(;;){
		hpery = 365 * 24;
		if	((T.tm_year & 3) == 0)
			hpery += 24;
		if	(time < hpery)
			break;
		cumdays += hpery / 24;
		T.tm_year++;
		time -= hpery;
	}
	if	(dst && daylight && time >= DSTSTART && time < DSTEND){
		time++;
		T.tm_isdst = 1;
	}
	else
		T.tm_isdst = 0;
	T.tm_hour = time % 24;
	time /= 24;
	T.tm_yday = (int)time;
	cumdays += (int)time + 4;
	T.tm_wday = cumdays % 7;
	time++;
	if	((T.tm_year & 3) == 0){
		if	(time > 60)
			time--;
		else if (time == 60){
			T.tm_mon = 1;
			T.tm_mday = 29;
			return(&T);
		}
	}
	for	(T.tm_mon = 0; Days[T.tm_mon] < time; T.tm_mon++)
		time -= Days[T.tm_mon];
	T.tm_mday = time;
	return(&T);
}

struct tm *gmtime(const long *clock)
{
 return(comtime(*clock, 0));
}

struct tm *localtime(const long *clock)
{	long	x;
	register struct tm	*tm;
	x = *clock - timezone;
	return(comtime(x, 1));
}


char	*asctime(const struct tm *T)
{	static	char	a[36];
	sprintf(a, "%s %02d %s %04d %02d:%02d:%02d  jour=%02d", Weekday[T->tm_wday],
	T->tm_mday,Months[T->tm_mon+1],T->tm_year+1900,T->tm_hour, T->tm_min,
	T->tm_sec,T->tm_yday);
	return(a);}

void What_Date(struct Datum *Dt)
{   _AH = 0x2a;
    geninterrupt(0x21);
    ((char *)Dt)[4]=_AL;
    ((char *)Dt)[0]=_DL;
    ((char *)Dt)[1]=_DH;
    ((int *)Dt)[1]=_CX;
}

void What_Time(struct temps *ti)
{
	_AH = 0x2c;
	geninterrupt(0x21);
        ((char *)ti)[0]=_CH;
	((char *)ti)[1]=_CL;
        ((char *)ti)[2]=_DH;
        ((char *)ti)[3]=_DL;
}

void main()
{
bb=((char *)malloc(28));
clrscr();
printf("\t\t UseTIME.c  15/04/90  rev 11/91\n");
printf("\n\nUse of DOS.h sous Interruption 21H ");
What_Date(&Dt);
printf("\nWhat_Date  :%s  %02d %s %4d ",Weekday[Dt.Js],Dt.day,Months[Dt.mon],Dt.year);
What_Time(&ti);
printf("\nWhat_Time  : %02dH%02dM%02dS et %2d centiemes ",ti.t_hour,ti.t_min,ti.t_sec,ti.t_hund);
getdate(&dt);
printf("\nAvec fonctions Dos.h : ");
printf("\nGetdate :  Annnee %5d  Jour:%3d  Mois :%3d",
     dt.da_year,dt.da_day,dt.da_mon);
gettime(&Wt);
printf ("\nGetTime : %2d H %2d M %2d S %3d /100 emes",
      Wt.ti_hour,Wt.ti_min,Wt.ti_sec,Wt.ti_hund);

sleep(1);
printf("\n\n\tUsage de TIME.h pour TimeStamp -> ctime et asctime\n ");
Lt=2700000L;
bb=ctime(&Lt);
printf("\nsi valeur mini de %14ld -> %s",Lt,asctime(&T));
Lt=1389273990L; /* 09 janvier 2014 */
bb=ctime(&Lt);
printf("\nsi valeur 1.389.273.990 -> %s",asctime(&T));
printf("\nEntrer New Valeur pour Ls : ");
scanf("%12ld",&Ls);
bb=ctime(&Ls);
printf("\nAsctime avec Ls=%12ld ---> %s",Ls,asctime(&T));
time(&Lt);
bb=ctime(&Lt);
printf("\nLecture Now via TIME    -> Lt=%12ld ",Lt);
printf("\nNow via ASCTIME         -> %s",asctime(&T));
bb=ctime(&Lt);
printf("\nNow via CTIME (-->bb)   -> %s",bb);
printf("\nPointeur de variable bb =%Fp",bb);
do {} while (!kbhit());
sleep(2);
}
